/*
gcc -c $(pkg-config --libs --cflags gtk+-3.0) project2.c && 
gcc project2.o $(pkg-config --libs --cflags gtk+-3.0) -rdynamic -o project2.exe &&
./project2.exe
*/

#include <gtk/gtk.h>

int pos[100];
int n = -1;

void do_drawing(cairo_t *cr) {
	cairo_set_source_rgb(cr, 0.6, 0.6, 0.6);
	cairo_set_line_width(cr, 1);
	for(int i=0; i<=n; i++) {
		cairo_rectangle(cr, pos[2*i]-10, pos[2*i+1]-10, 20,20);
	}
	cairo_stroke_preserve(cr);
	cairo_fill(cr);
}

void do_drawing0(cairo_t *cr) {
	cairo_rectangle(cr, 20, 20, 120, 80);
	cairo_set_source_rgb(cr, 0.6, 0.6, 0.6);
	cairo_set_line_width(cr, 1);
	cairo_stroke_preserve(cr);
	cairo_fill(cr);
}

int do_refresh(GtkWidget *widget, cairo_t *cr, gpointer txt) {
	do_drawing(cr);
	return 1;
}

int do_click(GtkWidget *widget, gpointer txt) {
	int x,y;
	GdkModifierType mask;
	gdk_window_get_device_position(gtk_widget_get_window(widget), 
		gtk_get_current_event_device(), &x, &y, &mask);
	n++;
	pos[2*n] = x;
	pos[2*n+1] = y;
	gtk_widget_queue_draw(widget); // redraw
	return 1;
}

int main(int argc, char *argv[])
{
    GtkBuilder      *builder; 
    GtkWidget       *window;
    
    gtk_init(&argc, &argv);

    builder = gtk_builder_new();
    gtk_builder_add_from_file (builder, "./project2.glade", NULL);

    window = GTK_WIDGET(gtk_builder_get_object(builder, "window"));
    gtk_builder_connect_signals(builder, NULL);

    gtk_widget_show(window);
    gtk_main();
    return 0;
}
